; ------------------------------------------------------------------------
;
;                          ################
;                          # Flash Savior #
;                          ################
;      de Julien Monville (Pen) et Thibaut Barthlemy (Thibaut)
;
; ------------------------------------------------------------------------
;
; Ceci est le fichier principal du programme, celui  donner en pture
; au compilateur.
;
; + L'interface graphique se trouve dans "interfac.asm" (Julien Monville)
; + Les routines de gestion de la FAT & VAT virtuelle sont codes dans
;   "backup.asm" (Thibaut Barthlemy)
;
; ------------------------------------------------------------------------


	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	;xxx	les  enttes :)		xxx
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	include		"doorsos.h"
	include		"graphlib.h"
	include		"filelib.h"
	include		"misc\macros.asm"
	

	xdef		_main
	xdef		_ti89
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	;xxx	les  routines :)	xxx
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
_main:	include		"interfac.asm"			;JM
	include		"backup.asm"			;TB
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	

	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	;xxx	les sprites :)		xxx
	;xxx	(avec tipicture)	xxx
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	include		"sprites\arrow.h"
	include		"sprites\FL_S_E.h"
	include		"sprites\eclair.h"
	include		"sprites\dd_1.h"
	include		"sprites\dd_2.h"
	include		"sprites\dd_3.h"
	include		"sprites\dd_4.h"
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	
	
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	;xxx	les variables :)	xxx
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	include		"misc\vars.asm"
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	;xxx	les chaines :)		xxx
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	include		"misc\strings.asm"
	;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


	end

