;By Julien MONVILLE 17/04/01 17:04 (C)


;I]	INITIALISATION DE L'ECRAN :

	
	include		"misc\credits.asm"			; :)))



;	1/	effaons tout :
	push.w		#3
	jsr		doorsos::ST_busy				;efface busy. nan, srieux ?
	addq.l		#2,a7
	
	jsr		graphlib::clr_scr
	
;	2/	dessinons le noir de base :
	frame		0,0,159,99					;dessine
	frame		1,1,157,97					;le (joli)
	frame		3,3,153,93					;cadre noir.


	;arrondi des angles
	move.b		#%01111111,LCD_MEM
	move.b		#%11111110,LCD_MEM+19
	move.b		#%01111111,LCD_MEM+30*99
	move.b		#%11111110,LCD_MEM+30*99+19

	move.b		#%11100000,LCD_MEM+30*2
	move.b		#%00000111,LCD_MEM+30*2+19
	move.b		#%11100000,LCD_MEM+30*97
	move.b		#%00000111,LCD_MEM+30*97+19
	
	
	move.b		#%11001111,LCD_MEM+30*3
	move.b		#%11110011,LCD_MEM+30*3+19
	move.b		#%11001111,LCD_MEM+30*96
	move.b		#%11110011,LCD_MEM+30*96+19
	
	
	SetFont		#0
	WriteStr	#58,#60,#4,folder
	WriteStr	#58,#75,#4,file

	move.w		#85,d0						;on dfini x
	move.w		#61,d1						;on dfini y
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	lea		arrow_folder(PC),a0				;on charge l'adresse de arrow_folder dans a0
	jsr		graphlib::put_sprite_mask
	move.w		#86,d0						;on dfini x
	move.w		#75,d1						;on dfini y
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	lea		arrow_file(PC),a0				;on charge l'adresse de arrow_file dans a0
	jsr		graphlib::put_sprite_mask


	jsr		graphlib::gray4
	move.w		#1,graphlib::choosescreen
	move.l		graphlib::plane1,a1
	jsr		graphlib::clr_scr
	

	move.w		#(960-1),d0					;-1 puisque dbra branche jusqu' d0=0
	move.l		graphlib::plane0,a0				;
	move.l		graphlib::plane1,a1				;copie le plane 0
\loop_copy_plane:							;dans
	move.l		(a0)+,(a1)+					;le plane 1
	dbra.s		d0,\loop_copy_plane				;


;	3/	dessinons les sprites statiques en 4  gris :
	move.w		#14,d0						;on dfini x
	move.w		#15,d1						;on dfini y
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	lea		FL_S_E_p0(PC),a0				;on charge l'adresse du sprite dans a0
	move.l		graphlib::plane0,a1				;on dessine dans le plan0
	jsr		graphlib::put_sprite_mask
	move.w		#14,d0						;on dfini x
	move.w		#15,d1						;on dfini y
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	lea		FL_S_E_p1(PC),a0				;on charge l'adresse du sprite dans a0
	move.l		graphlib::plane1,a1				;on dessine dans le plan1
	jsr		graphlib::put_sprite_mask
	move.w		#28,d0
	move.w		#0,d1
	lea		eclair_p0(PC),a0
	clr.b		d3						;d3.b = constant mask (0->transparent)
	move.l		graphlib::plane1,a1
	jsr		graphlib::put_sprite_mask			;mask pasque eclair chevauche FL_S_E

;	4/	initialisation de l'animation :
	bsr		reset_anim					;initialisation de l'animation

	move.w		#6,-(a7)			;on free
	jsr		doorsos::OSFreeTimer		;le timer 6 (<=> user_timer)
	lea		2(a7),a7

	move.l		#5,-(a7)			;20 pour 1 seconde, donc 5 <=> 5/20 = 1/4 seconde
	move.w		#6,-(a7)			;pour le timer 6 (<=> user_timer)
	jsr		doorsos::OSRegisterTimer	;et hop !
	lea		6(a7),a7			;et pas lea 4(a7),a7 -> quelle burne je suis ! #devil#

	bsr		animation
	
;	5/	prparation FAT/VAT
preparation_FAT_VAT:
	bsr		Initialiser_FATVAT_Virtuelle			;TB - voir dans "backup.asm" pour connatre son rle
	move.l		VAT_Add_Backup,a0				
	move.w		12(a0),d0					;TB - d0 = handle de la FAT virtuelle
	DEREF		d0,a0						;TB - a0 = adresse FAT virtuelle
	move.l		a0,debfich					;TB - debfich pointe aussi sur le fichier
	move.w		2(a0),nb_folders
	lea		4(a0),a0
	move.l		a0,folder_name_adresse				;adresse 1er nom folder
	move.w		#1,numfolder
	
afficher_rep:
	move.l		folder_name_adresse,a1
	move.w		12(a1),d0					;TB - d0 = adresse relative de la VAT associe
	move.l		debfich,a4
	lea		2(a4,d0.w),a0					;TB - a0 = adresse absolue de la VAT associe
	move.w		(a0),nb_files					;TB - pas 2(a0) car je ne sauve pas les tailles relles
	move.w		#1,numfile
	lea		2(a0),a0					;TB - donc 2(a0) pointe sur la premire entre
	move.l		a0,file_name_adresse				;adresse 1er nom file (si existe), sinon corrompu
	jsr		portset_plane0
	WriteStr	#98,#60,#4,blanc24				;font 0 oblige  faire 24 blcs
	jsr		portset_plane1
	WriteStr	#98,#60,#4,blanc24
	move.l		folder_name_adresse,a1				;(2 pxls chacun=48pxls soit 8 char de 6 pix)
;	clr.b		8(a1)						;TB - c'est quoi a (provoque des violations d'accs) ?
	WriteStrA	#98,#60,#4,a1
	jsr		portset_plane0
	move.l		folder_name_adresse,a1
	WriteStrA	#98,#60,#4,a1
	tst.w		nb_files					;si pas de files, on le dit gentiment ! 
	beq		nofile						;(obvious isn't it ?)


afficher_file:
;	move.l		a0,adresse_contenu				;sauvons l'adresse du contenu affich ! se mefier de portset
	WriteStr	#98,#75,#4,blanc24				;font 0 oblige  faire 24 blcs
	jsr		portset_plane1
	WriteStr	#98,#75,#4,blanc24
	move.l		file_name_adresse,a2				;(2 pxls chacun=48pxls soit 8 char de 6 pix)
;	clr.b		8(a2)						;TB - c'est quoi a (provoque des violations d'accs) ?
	WriteStrA	#98,#75,#4,a2
	jsr		portset_plane0
	move.l		file_name_adresse,a2
	WriteStrA	#98,#75,#4,a2
	bra.s		main_loop	



;II]	boucle principale (gre le clavier, ainsi que l'animation)

;	1/	boucle principale ( d'o l'appelation main_loop pour les anglophobes ;) )


	;======================
loop_anim:
	bsr		animation
	move.w		#6,-(a7)
	jsr		doorsos::OSTimerRestart
	addq.l		#2,a7

main_loop:
	tst.w		doorsos::kb_globals+$1C
	bne.s		quelle_touche_?					;si =/= 0, une touche a t presse
	move.w		#6,-(a7)
	jsr		doorsos::OSTimerExpired
	addq.l		#2,a7
	tst.w		d0						;si expir : d0 = 1
	beq.s		main_loop


	bra.s		loop_anim
	;======================



;III]	Routines  executer sous certaines conditions seulements

;	1/	mais quelle touche a donc t presse ?
quelle_touche_?:
	move.w		doorsos::kb_globals+$1E,d0
	clr.w		doorsos::kb_globals+$1C

	cmp.w		#KEY_RIGHT,d0					;flche droite
	beq		next_file

	cmp.w		#KEY_LEFT,d0					;flche gauche
	beq		previous_file

	cmp.w		#KEY_DOWN,d0					;flche basse
	beq		next_folder

	cmp.w		#KEY_UP,d0					;flche haute
	beq		previous_folder

	move.w		touche_actu,d1					;[ F1 ] sur 92+
	cmp.w		d1,d0						;[ CATALOG ] (ben quoi, c bien un catalogue, non ?) 
	beq		actualiser_backup
	
	cmp.w		#264,d0						;[ ESC ]
	beq		fin

	cmp.w		#13,d0						;[ ENTER ]
	bne		continuer
	tst.w		nb_files					;check si il y a qq chose  recuperer ds le folder
	beq		continuer
	move.l		folder_name_adresse,a5				;TB - premier paramtre (voir "backup.asm")
	move.l		file_name_adresse,a6				;TB - deuxime paramtre
	bsr		recuperation					;c pas de mon ressort (hein Thibaut ;) )
	bsr		dialogue
	
continuer:
	bra		main_loop					; si autre touche, on revient ds main_loop




;	2/	routine d'animation
animation:
	move.l		adresse_plan_courrant,a2

	;plan 0
	move.w		#15,d0						;on dfini x
	move.w		#57,d1						;on dfini y
	move.l		a2,a0						;on charge l'adresse du sprite dans a0
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	move.l		graphlib::plane0,a1				;on dessine dans le plan0
	jsr		graphlib::put_sprite_mask
	
	adda.l		decalage_des_plans,a2
	

	;plan 1
	move.w		#15,d0						;on dfini x
	move.w		#57,d1						;on dfini y
	move.l		a2,a0						;on charge l'adresse du sprite dans a0
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	move.l		graphlib::plane1,a1				;on dessine dans le plan0
	jsr		graphlib::put_sprite_mask
	
	addq.b		#1,n_sprite_disk
	
	cmp.b		#4,n_sprite_disk
	bcc.s		reset_anim
		
	adda.l		decalage_des_plans,a2	
	move.l		a2,adresse_plan_courrant
	rts

reset_anim:
	move.b		#0,n_sprite_disk
	lea		dd_1_p0(PC),a0
	move.l		a0,adresse_plan_courrant
	move.l		#(dd_1_p1-dd_1_p0),decalage_des_plans
	rts
;fin  d'animation	
	

;	3/	routine de changement de file/folder


nofile:
	WriteStr	#98,#75,#4,blanc24				;font 0 oblige  faire 24 blcs (2 pxls chacun=48pxls soit 8 char de 6 pix)
	jsr		portset_plane1
	WriteStr	#98,#75,#4,blanc24
	WriteStr	#98,#75,#4,no_file				;sinon, on affiche "no file !"
	bra		main_loop


next_file:
	tst.w		nb_files					;si pas de files, retourne ds main_loop
	beq		main_loop					;
	move.l		file_name_adresse,a1
	lea		16(a1),a1					;on avance de 16
	move.l		a1,file_name_adresse
	addq.w		#1,numfile
	move.w		numfile,d2
	move.w		nb_files,d3
	cmp.w		d2,d3
	bcc		afficher_file
	subq.w		#1,numfile
	lea		-16(a1),a1					;on recule de 16
	move.l		a1,file_name_adresse
	bra		main_loop

previous_file:
	tst.w		nb_files					;si pas de files, retourne ds main_loop
	beq		main_loop					;
	move.l		file_name_adresse,a1
	lea		-16(a1),a1					;on recule de 16
	move.l		a1,file_name_adresse
	subq.w		#1,numfile
	tst.w		numfile						;comparons numfolder  0
	bne		afficher_file					;si numfold=/=0,  alors on va  afficher_rep
	addq.w		#1,numfile					;sinon...
	lea		16(a1),a1					;on avance de 16
	move.l		a1,file_name_adresse
	bra		main_loop					;et on retourne ds main_loop



next_folder:
	move.l		folder_name_adresse,a1
	lea		14(a1),a1					;on avance de 14
	move.l		a1,folder_name_adresse
	addq.w		#1,numfolder
	move.w		numfolder,d2
	move.w		nb_folders,d3
	cmp.w		d2,d3
	bcc		afficher_rep
	subq.w		#1,numfolder
	lea		-14(a1),a1					;on recule de 14
	move.l		a1,folder_name_adresse
	bra		main_loop					;et on retourne ds main_loop

previous_folder:
	move.l		folder_name_adresse,a1
	lea		-14(a1),a1					;on recule de 14
	move.l		a1,folder_name_adresse
	subq.w		#1,numfolder
	tst.w		numfolder					;comparons numfolder  0
	bne		afficher_rep					;si numfold=/=0,  alors on va  afficher_rep
	addq.w		#1,numfolder					;sinon...
	lea		14(a1),a1					;on avance de 14
	move.l		a1,folder_name_adresse
	bra		main_loop					;et on retourne ds main_loop


;	4/	routine de changement de plan pour les ROM_CALLS


portset_plane0:
	move.w		#127,-(a7)
	move.w		#239,-(a7)
	move.l		graphlib::plane0,-(a7)
	jsr		doorsos::PortSet
	lea		8(a7),a7
	rts
	
portset_plane1:
	move.w		#127,-(a7)
	move.w		#239,-(a7)
	move.l		graphlib::plane1,-(a7)
	jsr		doorsos::PortSet
	lea		8(a7),a7
	rts

	
;	5/	routine de dialogue


dialogue:
	
	;==================================PLAN 0 ==================================
	;j'suis dsol, mais a marche pas proprement avec graphlib, et en +, memtoscr foire avec graphlib de DoosOS :'(
	;move.w		#4,d0						;x1 = 32
	;move.w		#38,d1						;y1 = 38
	;move.w		#12,d2						;x2 = 128
	;move.w		#23,d3						;y2 = 61
	;move.l		graphlib::plane0,a1
	;jsr		graphlib::scrtomem				;on sauve l'cran
	;move.w		d4,handle_screen_effac_plane0
	;donc on fait a :
	;- - - - - - - - - - - - - - - - - - - - - -
	move.l		#4+12*23,-(a7)					;format + L* H
	jsr		doorsos::HeapAllocHigh
	addq.l		#4,a7
	;tst.w		d0
	;beq		memory_error
	move.w		d0,handle_screen_effac_plane0
	
	move.l		graphlib::plane0,a1
	adda.l		#38*30+4,a1					;a1 pointe sur le haut gauche du truc  sauvegarder
	DEREF		d0,a0						;a0 = pointeur handle de sauvegarde plane0
	move.w		#23,(a0)+					;vertical size
	move.w		#12,(a0)+					;horizontal size
	move.l		#23-1,d3					;23 lignes
loop_sauve_plane0:
	move.l		#3-1,d2						;3 loop *4 = 12 octets de large
loop_sauve_ligne_plane0:
	move.l		(a1)+,(a0)+
	dbra.s		d2,loop_sauve_ligne_plane0
	adda.l		#30-12,a1
	dbra.s		d3,loop_sauve_plane0
	;- - - - - - - - - - - - - - - - - - - - - -
	move.l		graphlib::plane0,a1
	;fill with white
	move.w		#33,d0
	move.w		#39,d1
	move.w		#94,d2
	move.w		#21,d3
	move.w		#1,d4
	jsr		graphlib::fill
	frame		33,39,94,21					;39,39,120,60
	move.b		#%00111111,39*30+4(a1)				;on arrondi les angles
	move.b		#%11111110,39*30+15(a1)
	move.b		#%00111111,60*30+4(a1)
	move.b		#%11111110,60*30+15(a1)
	

	;==================================PLAN 1 ==================================
	;j'suis dsol, mais a marche pas proprement avec graphlib, et en +, memtoscr foire avec graphlib de DoosOS :'(
	;move.w		#4,d0						;x1 = 32
	;move.w		#38,d1						;y1 = 38
	;move.w		#12,d2						;x2 = 128
	;move.w		#23,d3						;y2 = 61
	;move.l		graphlib::plane1,a1
	;jsr		graphlib::scrtomem				;on sauve l'cran
	;move.w		d4,handle_screen_effac_plane1
	;donc on fait a :
	;- - - - - - - - - - - - - - - - - - - - - -
	move.l		#4+12*23,-(a7)					;format + L* H
	jsr		doorsos::HeapAllocHigh
	addq.l		#4,a7
	;tst.w		d0
	;beq		memory_error
	move.w		d0,handle_screen_effac_plane1
	
	move.l		graphlib::plane1,a1
	adda.l		#38*30+4,a1					;a1 pointe sur le haut gauche du truc  sauvegarder
	DEREF		d0,a0						;a0 = pointeur handle de sauvegarde plane0
	move.w		#23,(a0)+					;vertical size
	move.w		#12,(a0)+					;horizontal size
	move.l		#23-1,d3					;23 lignes
loop_sauve_plane1:
	move.l		#3-1,d2						;3 loop *4 = 12 octets de large
loop_sauve_ligne_plane1:
	move.l		(a1)+,(a0)+
	dbra.s		d2,loop_sauve_ligne_plane1
	adda.l		#30-12,a1
	dbra.s		d3,loop_sauve_plane1
	;- - - - - - - - - - - - - - - - - - - - - -
	move.l		graphlib::plane1,a1
	;fill with white
	move.w		#33,d0
	move.w		#39,d1
	move.w		#94,d2
	move.w		#21,d3
	move.w		#1,d4
	jsr		graphlib::fill
	frame		33,39,94,21					;39,39,120,60
	move.b		#%01111111,39*30+4(a1)				;on arrondi les angles
	move.b		#%11111100,39*30+15(a1)
	move.b		#%01111111,60*30+4(a1)
	move.b		#%11111100,60*30+15(a1)
	
	;. . . . . . . . . . . . . . . . . .	

	;shadow
	move.l		graphlib::plane1,a0
	move.w		#33,d0
	move.w		#38,d1
	move.w		#125,d2
	move.w		#38,d3
	jsr		graphlib::line
	move.w		#32,d0
	move.w		#39,d1
	move.w		#32,d2
	move.w		#59,d3
	jsr		graphlib::line


	;Quelle bate de dialogue doit on afficher ?
	cmp.w		#0,d7
	bne.s		dj_archiv_?
tout_est_OK:
	SetFont		#0
	bsr		portset_plane1
	WriteStr	#51,#47,#4,succes
	bsr		portset_plane0
	WriteStr	#51,#47,#4,succes
	bra		fin_dialogue
dj_archiv_?:
	cmp.w		#1,d7
	bne.s		var_en_ram
	SetFont		#0
	bsr		portset_plane1
	WriteStr	#53,#47,#4,archiv
	bsr		portset_plane0
	WriteStr	#53,#47,#4,archiv
	bra		fin_dialogue
var_en_ram:
	cmp.w		#2,d7
	bne.s		FLB_actualis
	SetFont		#0
	bsr		portset_plane1
	WriteStr	#51,#47,#4,RAM
	bsr		portset_plane0
	WriteStr	#51,#47,#4,RAM
	bra.s		fin_dialogue
FLB_actualis:
	SetFont		#0
	bsr		portset_plane1
	WriteStr	#45,#47,#4,update
	bsr		portset_plane0
	WriteStr	#45,#47,#4,update


;--------------------------------------

fin_dialogue:
	Wait		#7
;	move.w		#4,d0						;x1 = 32
;	move.w		#38,d1						;y1 = 38
;	move.w		#12,d2						;x2 = 128
;	move.w		#23,d3						;y2 = 61
;	move.w		handle_screen_effac_plane0,d4
;	move.l		graphlib::plane0,a1
;	jsr		graphlib::memtoscr
	
	move.w		#32,d0						;on dfini x
	move.w		#38,d1						;on dfini y
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	move.w		handle_screen_effac_plane0,d4
	DEREF		d4,a0						;on charge l'adresse du sprite dans a0
	move.l		graphlib::plane0,a1				;on dessine dans le plan0
	jsr		graphlib::put_sprite_mask
	move.w		handle_screen_effac_plane0,-(a7)
	jsr		doorsos::HeapFree
	addq.l		#2,a7
	
;	move.w		#4,d0						;x1 = 32
;	move.w		#38,d1						;y1 = 38
;	move.w		#12,d2						;x2 = 128
;	move.w		#23,d3						;y2 = 61
;	move.w		handle_screen_effac_plane1,d4
;	move.l		graphlib::plane1,a1
;	jsr		graphlib::memtoscr
	
	move.w		#32,d0						;on dfini x
	move.w		#38,d1						;on dfini y
	move.b		#$FF,d3						;d3.b = constant mask (FF->opaque)
	move.w		handle_screen_effac_plane1,d4
	DEREF		d4,a0						;on charge l'adresse du sprite dans a0
	move.l		graphlib::plane1,a1				;on dessine dans le plan0
	jsr		graphlib::put_sprite_mask
	move.w		handle_screen_effac_plane1,-(a7)
	jsr		doorsos::HeapFree
	addq.l		#2,a7
	rts


;	6/	Wait

Wait_check_HW:	cmp.b		#1,HW_VERSION
		beq.s		Wait
		addq.b		#3,d1
		
Wait:		move.l		#$FFFFFFFF,d0
empty_loop:	dbra.s		d0,empty_loop
		dbra.s		d1,Wait
	rts


;	7/	fin


fin:	
	jsr		doorsos::PortRestore
	clr.w		graphlib::choosescreen			;set all graphlib functions to Black and White mode
	jsr		graphlib::gray2				;restores Black and White mode

	

;les credits
	jsr		graphlib::clr_scr
	bsr		Archiver_Les_Recups
	
	tst.b		bo_credits_enabled_?
	bne.s		The_END					;hh, ils passeront pas au travers des credits #devil#
	SetFont		#0					;moches ou pas, ils les aurront :D !
	WriteStr	#61,#39,#4,Julien
	WriteStr	#78,#47,#4,et
	WriteStr	#56,#55,#4,Thibaut
	Wait		#25

The_END:	
	rts
	

